Index: apps/app_externalivr.c
===================================================================
--- apps/app_externalivr.c	(revision 115577)
+++ apps/app_externalivr.c	(working copy)
@@ -340,6 +340,7 @@
 		int ms;
 		int exception;
 		int ready_fd;
+		int test_available_fd;
 		int waitfds[2] = { child_errors_fd, child_commands_fd };
 		struct ast_channel *rchan;
 
@@ -367,6 +368,8 @@
 			goto exit;
 		}
 
+		test_available_fd = open("/dev/null", O_RDONLY);
+
 		setvbuf(child_events, NULL, _IONBF, 0);
 		setvbuf(child_commands, NULL, _IONBF, 0);
 		setvbuf(child_errors, NULL, _IONBF, 0);
@@ -500,7 +503,7 @@
 			} else if (ready_fd == child_errors_fd) {
 				char input[1024];
 
-				if (exception || feof(child_errors)) {
+				if (exception || (dup2(eivr_commands_fd, test_available_fd) == -1) || feof(child_errors)) {
 					ast_chan_log(LOG_WARNING, chan, "Child process went away\n");
 					res = -1;
 					break;
@@ -533,6 +536,9 @@
 	if (child_errors)
 		fclose(child_errors);
 
+	if (test_available_fd)
+		close(test_available_fd);
+
 	if (child_stdin[0])
 		close(child_stdin[0]);
 
